\\ ---------- Methods for the point counting ----------

S1(s,t,K) = if(K==0,ellinit([s/t,-(2+s/t),0,1+s/t,0]),ellinit(Mod([s/t,-(2+s/t),0,1+s/t,0],K.pol),K));

S2(s,t,K) = if(K==0,ellinit([s/t-4,-2,0,1,0]),ellinit(Mod([s/t-4,-2,0,1,0],K.pol),K));

countS1(s,t) = {
	    my(p=s.p,k=poldegree(s.mod));
	    if(t==0,return(6*p^k));
	    if(s==0,return(3*p^k));
	    if(s+t==0,return(2*(p^k+1)-#polrootsmod(3+x^2,ffgen(p^k))));
	    if(s-8*t==0,return(p^k+2-#polrootsmod(3+x^2,ffgen(p^k))));
	    return(S1(s,t).no);
};

countS2(s,t) = {
	    my(p=s.p,k=poldegree(s.mod));
	    if(t==0,return(8*p^k));
	    if(s-4*t==0,return(2*p^k));
	    if(s==0 || s-8*t==0,return(p^k+2-#polrootsmod(1+x^2,ffgen(p^k))));
	    return(S2(s,t).no);
};

countX(p,k) = {
	 my(modP,z,gen1,gen2,fieldElements,n);
	 p = idealfactor(K,p)[1,1];
	 modP = nfmodprinit(K,p);
	 z = nfmodpr(K,X/16,modP);
	 gen1 = ffgen(z);
	 gen2 = ffgen(idealnorm(K,p)^k);
	 z = ffmap(ffembed(gen1, gen2), z);
	 fieldElements = List();
	 [p,k] = factor(idealnorm(K,p)^k)[1,];
	 forvec(v=vector(k,i,[0,p-1]),listput(fieldElements,sum(i=0,k-1,v[i+1]*gen2^i)));
	 n = 0;
	 n += countS1(0*gen2,1+0*gen2)*countS2(1+0*gen2,z*0);
	 n += parsum(t=1,#fieldElements,countS1(1+0*gen2,fieldElements[t])*countS2(fieldElements[t],z));
	 n += 30*p^k;
	 n
};

phi1(t,x,y) = [(x+4*t*(-1+t*(-1+x))*(-1+x))/x,4*t*((-1+x)*x*(1+t*(-3+4*t*(-1+x)+x))+2*t*(-1+t*(-1+x^2))*y)/x^2];

phi2(t,x,y,xMod) = [-((1+x)^2*(x-t*(1+x)^2)^2*(x-8*t*x+4*t^2*(1+x)^2))/((-1+x)^2*x*(x+t*(1-6*x+x^2))^2),1/(-2*(1-8*t)*(-1+x)^3*x^2*(t+x+t*(-6+x)*x)^3)*((-4+32*t)*(1+x)*(-x+t*(1+x)^2))*(((-1+8*t)*(-1+x)*x*(1+x)*(-x+t*(1+x)^2)*(x-8*t*x+4*t^2*(1+x)^2)*(x+t*(1-6*x+x^2)))-2*xMod*((x^4+t^4*(1+x)^4*(1-28*x+70*x^2-28*x^3+x^4)+4*t^3*x*(1+x)^2*(1+12*x-42*x^2+12*x^3+x^4)-2*t^2*x^2*(7-4*x-54*x^2-4*x^3+7*x^4)+t*(x^2-18*x^4+x^6)))*((-1+4*t)*x-2*t*y))];

fixedPointsPhiFrob(p,ell) = {
	my(xMod,gen,q,tFactorization);
	p = idealfactor(K,p)[1,1];
	gen = nfmodprinit(K,p);
	xMod = nfmodpr(K,X,gen);
	q = idealnorm(K,p);
	gen = ffgen(xMod);
	tFactorization = factormod(x^(q+1)+1/8,gen)[,1]~;
	
	sum(i=1,#tFactorization,
		my(embedding,t1,xMod1,xFactorization,x1,x2,x1New,x2New,yFactorization,y1,y2,y1New,y2New,E,points,m1,m2);
		[t1,embedding] = ffextend(gen,tFactorization[i]);
		xFactorization = vecsort(factormod(elldivpol(S1(1,t1),ell),t1)[,1]~,f->-poldegree(f));
		[x1,embedding] = ffextend(t1,xFactorization[1]);
		t1 = ffmap(embedding,t1);
		xFactorization = ffmap(embedding,xFactorization);
		yFactorization = factormod(substvec(y^2+1/t*x*y-(x^3-(2+1/t)*x^2+(1+1/t)*x),[t,x],[t1,x1]),x1)[,1]~;
		[y1,embedding] = ffextend(x1,yFactorization[1]);
		t1 = ffmap(embedding,t1);
		x1 = ffmap(embedding,x1);
		xFactorization = ffmap(embedding,xFactorization);
		E = S1(1,t1);
		points = List([[x1,y1]]);
		for(i=1,ell-2,listput(points,elladd(E,points[#points],[x1,y1])));
		for(i=1,#xFactorization,
			for(j=1,#points,if(subst(xFactorization[i],x,points[j][1])==0,xFactorization[i] /= x-points[j][1]));
			if(poldegree(xFactorization[i])>0,xFactorization=xFactorization[i];break);
		);
		x2 = polrootsmod(xFactorization,y1)[1];
		y2 = polrootsmod(substvec(y^2+1/t*x*y-(x^3-(2+1/t)*x^2+(1+1/t)*x),[t,x],[t1,x2]),y1)[1];
		[x1New,y1New] = if(substvec(denominator(phi1(t,x,y)[1]),[t,x],[t1,x1])==0,[0],phi1(t1^q,x1^q,y1^q));
		[x2New,y2New] = if(substvec(denominator(phi1(t,x,y)[1]),[t,x],[t1,x2])==0,[0],phi1(t1^q,x2^q,y2^q));
		m1 = matrix(2,2);
		forvec(i=[[0,ell-1],[0,ell-1]],if([x1New,y1New]==elladd(E,ellmul(E,[x1,y1],i[1]),ellmul(E,[x2,y2],i[2])),m1[1,1]=i[1]+O(ell);m1[1,2]=i[2]+O(ell);break));
		forvec(i=[[0,ell-1],[0,ell-1]],if([x2New,y2New]==elladd(E,ellmul(E,[x1,y1],i[1]),ellmul(E,[x2,y2],i[2])),m1[2,1]=i[1]+O(ell);m1[2,2]=i[2]+O(ell);break));

		[t1,embedding] = ffextend(gen,tFactorization[i]);
		xMod1 = ffmap(embedding,xMod);
		t1 = xMod1/16/t1;
		xFactorization = vecsort(factormod(elldivpol(S2(1,t1),ell),t1)[,1]~,f->-poldegree(f));
		[x1,embedding] = ffextend(t1,xFactorization[1]);
		t1 = ffmap(embedding,t1);
		xMod1 = ffmap(embedding,xMod1);
		xFactorization = ffmap(embedding,xFactorization);
		yFactorization = factormod(substvec(y^2+(1/t-4)*x*y-(x^3-2*x^2+x),[t,x],[t1,x1]),x1)[,1]~;
		[y1,embedding] = ffextend(x1,yFactorization[1]);
		t1 = ffmap(embedding,t1);
		xMod1 = ffmap(embedding,xMod1);
		x1 = ffmap(embedding,x1);
		xFactorization = ffmap(embedding,xFactorization);
		E = S2(1,t1);
		points = List([[x1,y1]]);
		for(i=1,ell-2,listput(points,elladd(E,points[#points],[x1,y1])));
		for(i=1,#xFactorization,
			for(j=1,#points,if(subst(xFactorization[i],x,points[j][1])==0,xFactorization[i] /= x-points[j][1]));
			if(poldegree(xFactorization[i])>0,xFactorization=xFactorization[i];break);
		);
		x2 = polrootsmod(xFactorization,y1)[1];
		y2 = polrootsmod(substvec(y^2+(1/t-4)*x*y-(x^3-2*x^2+x),[t,x],[t1,x2]),y1)[1];
		[x1New,y1New] = if(substvec(denominator(phi2(t,x,y)[1]),[t,x],[t1,x1])==0,[0],phi2(t1^q,x1^q,y1^q,xMod1^q));
		[x2New,y2New] = if(substvec(denominator(phi2(t,x,y)[1]),[t,x],[t1,x2])==0,[0],phi2(t1^q,x2^q,y2^q,xMod1^q));
		m2 = matrix(2,2);
		forvec(i=[[0,ell-1],[0,ell-1]],if([x1New,y1New]==elladd(E,ellmul(E,[x1,y1],i[1]),ellmul(E,[x2,y2],i[2])),m2[1,1]=i[1]+O(ell);m2[1,2]=i[2]+O(ell);break));
		forvec(i=[[0,ell-1],[0,ell-1]],if([x2New,y2New]==elladd(E,ellmul(E,[x1,y1],i[1]),ellmul(E,[x2,y2],i[2])),m2[2,1]=i[1]+O(ell);m2[2,2]=i[2]+O(ell);break));
		poldegree(tFactorization[i])*(1-trace(m1)+2*q)*(1-trace(m2)+8*q)
	)
};



\\ ---------- Computations ----------

default(parisize,"1G")

K = nfinit(X^2+1);

primeList = [3-2*X,3+2*X,5-2*X,5+2*X,6-X,6+X,5-4*X,5+4*X,7,7-2*X,7+2*X,6-5*X,6+5*X,8-3*X,8+3*X,8-5*X,9-4*X,9+4*X,10-X,10+X,10-3*X,10+3*X,8-7*X,8+7*X,11-4*X,11+4*X,10-7*X,10+7*X,11-6*X,11+6*X,10-9*X,10+9*X,14-X,14+X,15-4*X,15+4*X,14-9*X,14+9*X,16-5*X,14-11*X,17-8*X];

E = ellinit([0,1-X,0,0,1],K);
E1 = S1(1,X/4,K);
E2 = S2(1,-X/16,K);

computeData(p) = {
	my(q,pIdeal,lFrob,lFrob2,lPhiFrob,trFrob,trFrob2,pol,trDiff);
	pIdeal = idealfactor(K,p)[1,1];
	q = idealnorm(K,p);
	lFrob = countX(p,1);
	lFrob2 = countX(p,2);
	trFrob = 1 + 33*q - q*(ellap(E1,pIdeal)+ellap(E2,pIdeal)) + 33*q^2 + q^3 - lFrob;
	trFrob2 = 1 + 33*q^2 - q^2*(ellap(E1,pIdeal)^2+ellap(E2,pIdeal)^2-4*q) + 33*q^4 + q^6 - lFrob2;
	pol = substvec(1+A*T+q*B*T^2+A*q^3*T^3+q^6*T^4,[A,B],[-trFrob,(trFrob^2-trFrob2)/(2*q)]);
	trDiff = factor(pol)[1,1];
	trDiff = trDiff/subst(trDiff,T,0);
	pol = [trDiff,pol/trDiff];
	trDiff = polcoef(pol[1]-pol[2],1,T);
	if(trDiff!=0,forprime(ell=2,oo,if(trDiff%ell!=0 && q%ell!=0,lPhiFrob=fixedPointsPhiFrob(p,ell);break)));
	if(lPhiFrob!=1+11*q-4*trDiff+26*q^2+16*q^3,pol=[pol[2],pol[1]]);
	[subst(p,X,I),lFrob,lFrob2,if(trDiff!=0,lPhiFrob,"-"),pol[1]*pol[2],pol[1],pol[2],ellap(E,pIdeal),ellap(E1,pIdeal),ellap(E2,pIdeal)]
};

print("Computing [p, L(F_p), L(F_p^2), L(phi*F_p), det(1-T*F_p|V), det(1-T*F_p|V-), det(1-T*F_p|V+), tr(F_p|H^1(E)), tr(F_p|H^1(E1)), tr(F_p|H^1(E2))]:");
apply(p->print(computeData(p)),primeList);

